using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Grid;

namespace ChildTableSorting
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		private Syncfusion.Windows.Forms.ButtonAdv buttonAdv1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			this.buttonAdv1 = new Syncfusion.Windows.Forms.ButtonAdv();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left)));
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(32, 72);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.OptimizeInsertRemoveCells = true;
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(624, 448);
			this.gridDataBoundGrid1.SmartSizeBox = false;
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 0;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.UseListChangedEvent = true;
			// 
			// buttonAdv1
			// 
			this.buttonAdv1.Appearance = Syncfusion.Windows.Forms.ButtonAppearance.Classic;
			this.buttonAdv1.ComboEditBackColor = System.Drawing.Color.Empty;
			this.buttonAdv1.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.buttonAdv1.IsMouseDown = false;
			this.buttonAdv1.Location = new System.Drawing.Point(32, 32);
			this.buttonAdv1.Name = "buttonAdv1";
			this.buttonAdv1.Size = new System.Drawing.Size(184, 23);
			this.buttonAdv1.TabIndex = 1;
			this.buttonAdv1.Text = "Add ChildRows to Empty Row";
			this.buttonAdv1.UseVisualStyle = false;
			this.buttonAdv1.Click += new System.EventHandler(this.buttonAdv1_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(712, 558);
			this.Controls.Add(this.buttonAdv1);
			this.Controls.Add(this.gridDataBoundGrid1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
		private void Form1_Load(object sender, System.EventArgs e)
		{
			DataTable parentTable = GetParentTable();
			DataTable childTable = GetChildTable();
 
			DataSet ds = new DataSet();
			ds.Tables.AddRange(new DataTable[]{parentTable, childTable});
 
			DataRelation parentToChild = new DataRelation("ParentToChild", parentTable.Columns["parentID"], childTable.Columns["ParentID"]);
 
			ds.Relations.Add(parentToChild);
   
			this.gridDataBoundGrid1.DataSource = ds;
			this.gridDataBoundGrid1.DataMember = parentTable.TableName;
			
 
			GridHierarchyLevel level0 = this.gridDataBoundGrid1.Binder.RootHierarchyLevel;
			GridHierarchyLevel level1 = this.gridDataBoundGrid1.Binder.AddRelation("ParentToChild");
		}
 
		private int numberParentRows = 14;
		private int numberChildRows = 50;

		private DataTable GetParentTable()
		{
			DataTable dt = new DataTable("ParentTable");
 
   
			dt.Columns.Add(new DataColumn("parentID")); //lower case p
			dt.Columns.Add(new DataColumn("ParentName"));
			dt.Columns.Add(new DataColumn("ParentDec"));
 
			for(int i = 0; i < numberParentRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i;//.ToString();
				dr[1] = string.Format("parentName{0}", i);
				dr[2] = string.Format("desc{0}", i);
				dt.Rows.Add(dr);
			}
 
			return dt;
		}
 
		private DataTable GetChildTable()
		{
			DataTable dt = new DataTable("ChildTable");
 
			dt.Columns.Add(new DataColumn("childID")); //lower case c
			dt.Columns.Add(new DataColumn("Name"));
			dt.Columns.Add(new DataColumn("ParentID")); //upper case P
   
			for(int i = 0; i < numberChildRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i.ToString();
				dr[1] = string.Format("ChildName{0}",i);
				int index = (i % numberParentRows);
				dr[2] = index < 10 ? index.ToString(): "0";
				dt.Rows.Add(dr);
			}
  
			return dt;
		}


		private void buttonAdv1_Click(object sender, System.EventArgs e)
		{
	
			GridRangeInfoList selectedRangeList = new GridRangeInfoList();
			this.gridDataBoundGrid1.Model.SelectedRanges.CopyTo(selectedRangeList,0);
			foreach(GridRangeInfo info in selectedRangeList	)
			{
				for(int i = info.Top; i<=info.Bottom ; i++)
				{
					GridBoundRecordState rs = this.gridDataBoundGrid1.Binder.GetRecordStateAtRowIndex(i);
					bool haslist = rs.HasChildList;
                    if(haslist)
					{
						bool isExpand = this.gridDataBoundGrid1.IsExpandedAtRowIndex(i);
						if( !isExpand )
							this.gridDataBoundGrid1.ExpandAtRowIndex(i);  
					}
				}
			}
		}

		
	}
}
